<template>
  <div class="q-pa-md" style="max-width: 350px">
    <div class="title">Team Plugin</div>

    <div v-if="loading" class="loading">Loading ...</div>
    <div v-if="!loading">
      <div>
        <q-btn @click="createTeams" label="Create teams from BO rooms" />
      </div>
      <div v-if="error !== null">
        <div class="error">error</div>
        <div>{{ error }}</div>
      </div>

      <div v-if="teams !== null">
        <q-list bordered class="rounded-borders team">
          <q-expansion-item
            v-for="teamId in Object.keys(teams)"
            :key="teams[teamId].teamName"
            switch-toggle-side
            expand-separator
            icon="perm_identity"
            label=""
          >
            <template v-slot:header class="team-header">
              <q-item-section class="team-name">
                <div>{{ teams[teamId].teamName }}</div>
              </q-item-section>
              <q-item-section>
                <q-btn icon="delete" @click="() => deleteTeam(teamId)" />
              </q-item-section>
            </template>

            <q-card>
              <q-card-section>
                <q-list bordered separator>
                  <q-item
                    clickable
                    v-ripple
                    v-for="(member, i) in teams[teamId].members"
                    :key="member.userId"
                  >
                    <q-item-section>{{ member.username }}</q-item-section>
                    <q-item-section side>{{ member.userRole }}</q-item-section>
                    <q-item-section side
                      ><q-btn
                        icon="delete"
                        @click="() => removeMember(String(teamId), i)"
                    /></q-item-section>
                  </q-item>
                  <q-item clickable v-ripple>
                    <q-item-section>{{
                      teams[teamId].sensorId
                    }}</q-item-section>
                    <q-item-section side>ZoomSense Bot</q-item-section>
                  </q-item>
                </q-list>
              </q-card-section>
            </q-card>
          </q-expansion-item>
        </q-list>
      </div>
    </div>
  </div>
</template>

<script lang="ts" allowjs="true">
import Vue from "vue";
import { saveBreakoutRoomsAsTeams } from "./createTeams";
import { Teams } from "./types";
import {
  ZoomSenseClientFirebaseDB,
  typedVuefirePlugin,
} from "@zoomsense/zoomsense-firebase";
Vue.use(typedVuefirePlugin);

export default Vue.extend({
  name: "Dashboard",
  data() {
    return {
      teams: null as null | Teams,
      error: null,
      loading: false,
    };
  },
  props: {
    firebase: {
      required: true,
      type: Object as () => ZoomSenseClientFirebaseDB,
    },
    context: {
      required: true,
      type: Object as () => { meetingid: string },
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        if (!this.context.meetingid) return;
        await this.$typedRtdbBind(
          "teams",
          this.firebase.ref(
            `/data/plugins/teamPlugin/${this.context.meetingid}`
          )
        );
      },
    },
  },
  methods: {
    async createTeams() {
      this.loading = true;

      // try save teams
      saveBreakoutRoomsAsTeams(this.context.meetingid, this.firebase)
        // successs -> stop loading, save teams and set error to null
        .then(() => {
          this.error = null;
          this.loading = false;
        })

        // error -> stop loading and show error
        .catch((error) => {
          this.loading = false;
          this.error = error;
        });
    },

    async deleteTeam(teamId: string) {
      await this.firebase
        .ref(`data/plugins/teamPlugin/${this.context.meetingid}/${teamId}`)
        .remove();
    },

    async removeMember(teamId: string, memberIndex: number) {
      await this.firebase
        .ref(
          `data/plugins/teamPlugin/${this.context.meetingid}/${teamId}/members/${memberIndex}`
        )
        .remove();
    },
  },
});
</script>

<style>
.title {
  font-size: 30px;
  font-weight: bold;
  margin-bottom: 10px;
}
.team-header {
  display: flex;
  flex-direction: row;
}
.team {
  margin: 30px;
  min-width: 500px;
}
.team-name {
  font-size: 20px;
  font-weight: bold;
  flex-grow: 5;
  min-width: 350px;
  vertical-align: middle;
  text-align: left;
}
.sucess {
  font-size: 20px;
  font-weight: bold;
  color: green;
  margin-top: 20px;
}
.error {
  font-size: 20px;
  font-weight: bold;
  color: red;
  margin-top: 20px;
}
.loading {
  font-size: 20px;
  font-weight: bold;
  margin-top: 20px;
}
.team-name-delete {
  display: flex;
  flex-direction: row;
  padding: 10px 15px;
  border-radius: 10px;
  font-size: larger;
}
</style>
